#include "board.h"

Board::Board(std::string filename, Physics *m_physics):GameObject(filename.c_str(), m_physics)
{
//	GameObject(filename.c_str()); // load texture

	memset (m_geom,0,sizeof(m_geom));

	setPosition(0.0f, 0.0f, 0.0f);	// initial position (where should we put it?)

//	m_geom[0] = m_physics->createBox(20*m_length, 10*m_width, 10*m_height);
	
//    for (int k=0; k < GPB; k++) 
//	{
//      if (m_geom[k]) 
//		  dGeomSetBody (m_geom[k],m_body);	// sets the body associated with a placeable geom
//    }
    
	dJointID my_fixed_joint = m_physics->createFixedJoin();
	dJointAttach(my_fixed_joint, m_body,0);
}

Board::~Board()
{
	// d'tor of GameObject will release texture, so nothing to do right here
}

void Board::draw()
{
	//glPushMatrix();

//	 dReal sides[3] = {m_length,m_width,m_height};
	 
//	 dsDrawBoxD (dBodyGetPosition(m_body),dBodyGetRotation(m_body),sides);



	glTranslatef(0.0f, 0.0f, 0.05f);
	glRotatef(13.0f, 1.0f, 0.0f, 0.0f);	

		glLineWidth(5.0f);

		glBegin(GL_LINES);
	// X = red
		glColor3f(1.0f, 0.0f, 0.0f);
		glVertex3f(-0.04,-0.065, 0.01 );
		glVertex3f(-0.04-0.764842187*0.1,-0.065+0.644217687*0.1, 0.01 );
		
		glEnd();

		glBegin(GL_LINES);
	// X = red
		glColor3f(1.0f, 0.0f, 0.0f);
		glVertex3f(0.04,-0.065, 0.01 );
		glVertex3f(0.04+0.764842187*0.1,-0.065+0.644217687*0.1, 0.01 );
		glEnd();




	//Enable texturing
	glEnable(GL_TEXTURE_2D);
	//bind the texture
	glBindTexture(GL_TEXTURE_2D, m_texture);
	glColor4f(1.0f, 1.0f, 1.0f, 0.4f);

	// draw board
	glBegin(GL_QUADS);
		//Top-left vertex (corner)
		glTexCoord2i(0,1);
		//glVertex2f(-0.10f, -0.10f);
		glVertex3f(-m_width/2.0f, -m_length/2.0f, 0.0f);
		
		//Bottom-left vertex (corner)
		glTexCoord2i(1,1);
		//glVertex2f(0.10f, -0.10f);
		glVertex3f(m_width/2.0f, -m_length/2.0f, 0.0f);
		
		//Bottom-right vertex (corner)
		glTexCoord2i(1,0);
	//	glVertex2f(0.10f, 0.10f);
		glVertex3f(m_width/2.0f, m_length/2.0f, 0.0f);
		
		//Top-right vertex (corner)
		glTexCoord2i(0,0);
		//glVertex2f(-0.10f, 0.10f);
		glVertex3f(-m_width/2.0f, m_length/2.0f, 0.0f);

	glEnd();

	// draw borders
	glBegin(GL_QUADS);
	// LEFT BORDER
		//Top-left vertex (corner)
		glTexCoord2i(0,1);
		glVertex3f(-m_width/2.0f, -m_length/2.0f, m_height);
		//Bottom-left vertex (corner)
		glTexCoord2i(1,1);
		glVertex3f(-m_width/2.0f, -m_length/2.0f, 0.0f);
		//Bottom-right vertex (corner)
		glTexCoord2i(1,0);
		glVertex3f(-m_width/2.0f, m_length/2.0f, 0.0f);	
		//Top-right vertex (corner)
		glTexCoord2i(0,0);
		glVertex3f(-m_width/2.0f, m_length/2.0f, m_height);
	// RIGHT BORDER
		//Top-left vertex (corner)
		glTexCoord2i(0,1);
		glVertex3f(m_width/2.0f, -m_length/2.0f, m_height);
		//Bottom-left vertex (corner)
		glTexCoord2i(1,1);
		glVertex3f(m_width/2.0f, -m_length/2.0f, 0.0f);
		//Bottom-right vertex (corner)
		glTexCoord2i(1,0);
		glVertex3f(m_width/2.0f, m_length/2.0f, 0.0f);	
		//Top-right vertex (corner)
		glTexCoord2i(0,0);
		glVertex3f(m_width/2.0f, m_length/2.0f, m_height);
	// TOP BORDER
		//Top-left vertex (corner)
		glTexCoord2i(0,1);
		glVertex3f(-m_width/2.0f, m_length/2.0f, m_height);
		//Bottom-left vertex (corner)
		glTexCoord2i(1,1);
		glVertex3f(-m_width/2.0f, m_length/2.0f, 0.0f);
		//Bottom-right vertex (corner)
		glTexCoord2i(1,0);
		glVertex3f(m_width/2.0f, m_length/2.0f, 0.0f);	
		//Top-right vertex (corner)
		glTexCoord2i(0,0);
		glVertex3f(m_width/2.0f, m_length/2.0f, m_height);
	glEnd();




	//Disable texturing
	glDisable(GL_TEXTURE_2D);
	
	//glPopMatrix();
}

