#include "Box.h"

const float lx = 0.02f;
const float ly = 0.08f;
const float lz = 0.05f;

Box::Box(Physics * physics, float centerX, float centerY, float centerZ):GameObject(physics)
{

	// create a box geometry 
	memset (m_geom,0,sizeof(m_geom));

	m_geom[0] = physics->createBox(lx, ly, lz); // create our box

	dMass m;	// density of 7
	dMassSetBox(&m, 7.0f, lx, ly, lz); // create mass of body
   
	dGeomSetBody (m_geom[0],m_body);	// sets the body associated with a placeable geom
    
    dBodySetMass (m_body,&m);	// Sets the mass of the body
	
	// initialize position
	setPosition(static_cast<double>(centerX), static_cast<double>(centerY), static_cast<double>(centerZ)); 
}
	/// dtor
Box::~Box()
{
	// gameObject frees everything used.
}

/// draw the box
void Box::draw()
{
	glPushMatrix();
	// so draw it:
	// translate somewhere (might be done by vis)
	setTransform(m_position, m_rotation);

	float sides[] = {lx, ly, lz};
	drawBox(sides); 

//	glBegin(GL_QUAD_STRIP);
//// we start at the left lower side:
//	glVertex3f(-lx/2.0f, -ly/2.0f, -lz/2.0f);
//	glVertex3f(-lx/2.0f, -ly/2.0f, lz/2.0f);
//	glVertex3f(-lx/2.0f, ly/2.0f, -lz/2.0f);
//	glVertex3f(-lx/2.0f, ly/2.0f, lz/2.0f);
//// upper side
//	glVertex3f(lx/2.0f, ly/2.0f, -lz/2.0f);
//	glVertex3f(lx/2.0f, ly/2.0f, lz/2.0f);
//// right side
//	glVertex3f(lx/2.0f, -ly/2.0f, -lz/2.0f);
//	glVertex3f(lx/2.0f, -ly/2.0f, lz/2.0f);
//// and downward pointing side
//	glVertex3f(-lx/2.0f, -ly/2.0f, -lz/2.0f);
//	glVertex3f(-lx/2.0f, -ly/2.0f, lz/2.0f);
//	glEnd();
//
//	// now begin for the other two sides:
//	glBegin(GL_QUADS);
//// front side
//	glVertex3f(-lx/2.0f, -ly/2.0f, -lz/2.0f);
//	glVertex3f(-lx/2.0f, ly/2.0f, -lz/2.0f);
//	glVertex3f(lx/2.0f, -ly/2.0f, -lz/2.0f);
//	glVertex3f(lx/2.0f, ly/2.0f, -lz/2.0f);
//// back side
//	glVertex3f(-lx/2.0f, -ly/2.0f, lz/2.0f);
//	glVertex3f(-lx/2.0f, ly/2.0f, lz/2.0f);
//	glVertex3f(lx/2.0f, -ly/2.0f, lz/2.0f);
//	glVertex3f(lx/2.0f, ly/2.0f, lz/2.0f);
//
//	glEnd();
//
	glPopMatrix();
}