// Class implementing a Box to limit the Ball (so that it won't fall on one of the sides)
#pragma once

#include "gameobject.h"
#include "physics.h"

class Box : public GameObject
{
private:
	/// hide std-ctor
	Box(){};
public:
	/** Constructs a Box (for not letting the ball fall below the paddels
	 *
	 * \param physics Physics engine used
	 * \param centerX, centerY, centerZ Position of the box
	 */
	Box(Physics * physics, float centerX, float centerY, float centerZ);
	/// dtor
	~Box();
	/// Draw the box
	void draw();
};