#include "bumper.h"

Bumper::Bumper(std::string filename, Physics *physics):GameObject(filename.c_str(), physics)
{
	m_scale = 0.02f;
	
	m_radius = 0.01f;	// 
	m_length = 0.01f;	// TODO: this must be linked to the size of the panel!!!!!!!

	memset (m_geom,0,sizeof(m_geom));
	dMass m;	

	dMassSetCappedCylinder (&m, 7.0f, 1, m_radius, m_length);
   
	//m_geom[0] = m_physics->createCyl(m_radius, m_length);
	m_geom[0] = m_physics->createCCyl(m_radius, m_length);
	
    for (int k=0; k < GPB; k++) 
	{
      if (m_geom[k]) 
		  dGeomSetBody (m_geom[k],m_body);	// sets the body associated with a placeable geom
    }
    
    dBodySetMass (m_body,&m);	// Sets the mass of the body



	//setPosition(-0.03f, 0.05f, 0.02f);

	//m_quadratic = gluNewQuadric();			
	//gluQuadricNormals(m_quadratic, GLU_SMOOTH);

	m_gllist = glGenLists(1);


	// TODO Texture Mapping !
	glNewList(m_gllist, GL_COMPILE);
	//gluCylinder(m_quadratic,0.5,0.5,1.0,10,10);
	// Draw Cylinder
	glBegin(GL_QUADS);
	unsigned int steps = 50;
	float radius = 0.5f;
	float topradius = radius + 0.3f;
	float height = 1.0f;
	float topheight = height + 0.2f;
	

	//bind the texture
	glBindTexture(GL_TEXTURE_2D, m_texture);
	

	for (unsigned int i = 0; i<steps; i++)
	{
		float alpha = (float) i * 360/steps;
		float nextalpha = (float) (i+1) * 360/steps;
		glTexCoord2f( (float) i/steps, 0);
		glVertex3f((float) cos(alpha*pi/180)*radius, (float) sin(alpha*pi/180)*radius, 0.0f);
		glTexCoord2f( (float) i/steps, 1);
		glVertex3f((float) cos(alpha*pi/180)*radius, (float) sin(alpha*pi/180)*radius, height);
		glTexCoord2f( (float)(i+1)/steps, 1);
		glVertex3f((float) cos(nextalpha*pi/180)*radius, (float) sin(nextalpha*pi/180)*radius, height);
		glTexCoord2f( (float)(i+1)/steps, 0);
		glVertex3f((float) cos(nextalpha*pi/180)*radius, (float) sin(nextalpha*pi/180)*radius, 0.0f);
	}
	glEnd();

	////Draw Top
	//glBegin(GL_TRIANGLE_FAN);
	//
	//glColor4f(0.0f, 1.0f, 1.0f, 1.0f);

	//glVertex3f(0.0f, 0.0f, topheight);
	//
	//for (unsigned int i = 0; i<steps; i++)
	//{
	//	float alpha = (float) i * 360/steps;
	//	float nextalpha = (float) (i+1) * 360/steps;
	//	glVertex3f(cos(alpha*pi/180)*topradius, sin(alpha*pi/180)*topradius, height);
	//	glVertex3f(cos(nextalpha*pi/180)*topradius, sin(nextalpha*pi/180)*topradius, height);
	//}
	//glEnd();
	glEndList();
}


Bumper::~Bumper(void)
{
	glDeleteLists(m_gllist, 1);
	//gluDeleteQuadric(m_quadratic);
}

void Bumper::draw(void)
{
	glPushMatrix();
	glTranslatef(m_position[0], m_position[1], m_position[2]);
	drawCylinder(m_radius, m_length);

	glScalef(m_scale, m_scale, m_scale);

	//Enable texturing
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, GetTexture());

	// Auf die Ebene des Boards anheben
	glTranslatef(0.0f, 0.0f, -0.4f);

	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);

	glCallList(m_gllist);

	//Disable texturing
	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
}
