#include "input.h"

Input::Input()
{
	// initialize member variables
	m_tracker = NULL;
	m_leftCode = 0;
	m_rightCode = 0;

	m_leftFlipperTriggered = false;
	m_rightFlipperTriggered = false;
}

Input::~Input()
{
}

void Input::setTracker(MarkerTracker * tracker, int leftFlipperCode, int rightFlipperCode)
{
	// register tracker
	m_tracker = tracker;

	m_leftCode = leftFlipperCode;
	m_rightCode = rightFlipperCode;
}


int Input::ProgressEvent()
{
  
	return 0;
}

void Input::update()
{
	if ((m_leftCode != 0) && (m_rightCode != 0))
	{
		m_leftFlipperTriggered = !m_tracker->markerIsTracked(m_leftCode);
		m_rightFlipperTriggered = !m_tracker->markerIsTracked(m_rightCode);
	}
} 

bool Input::leftFlipperTriggered()
{
	return m_leftFlipperTriggered;	
}

bool Input::rightFlipperTriggered()
{
	return m_rightFlipperTriggered;	
}
