#pragma once

#include "tracker/MarkerTracker.h"
/// Handling input from Tracker
class Input
{
private:
	/// Tracker as input
	MarkerTracker * m_tracker;
	/// Codes used to determine flippers
	int m_leftCode, m_rightCode;
	/// whether flippers are triggered
	bool m_leftFlipperTriggered, m_rightFlipperTriggered;
public:
	/// std-ctor
	Input();
	/// std-dtor
	~Input();

	/** Register tracker
	* @param tracker MarkerTracker used
	* @param leftFlipperCode, rightFlipperCode MarkerCode used for flippers
	*/
	void setTracker(MarkerTracker * tracker, int leftFlipperCode, int rightFlipperCode);

	/// refresh status
	void update(); 

	int ProgressEvent();

	/** Whether left flipper ist triggered
	* @param True if triggered, false otherwise
	*/
	bool leftFlipperTriggered();

	/** Whether right flipper ist triggered
	* @param True if triggered, false otherwise
	*/
	bool rightFlipperTriggered();
};
