#include ".\panel.h"


Panel::Panel(std::string filename, Physics *physics, float x, float y, float z):GameObject(filename.c_str(), physics)
{
	setPosition(x,y,z);
	m_angle = 0.0f;
	m_scale = 0.01f;

	m_radius = 0.01f;	// TODO: this must be linked to the size of the panel!!!!!!!
	m_length = 0.08f;	// TODO: this must be linked to the size of the panel!!!!!!!


	// we need a second body for the hinge
	//m_hinge_body = m_physics->createBody();
	//dGeomID m_hinge_geom = m_physics->createCCyl(m_radius, m_length);
	//dGeomSetBody (m_hinge_geom,m_hinge_body);
	
	// define hinge join
	m_hinge_joint = m_physics->createHingeJoin();
	//dJointAttach (m_hinge_joint,m_body,m_hinge_body);
	dJointAttach (m_hinge_joint,0,m_body);


	// define properties
	dJointSetHingeParam (m_hinge_joint, dParamLoStop, -0.4);
	dJointSetHingeParam (m_hinge_joint, dParamHiStop, 0.7);
	dJointSetHingeParam (m_hinge_joint, dParamBounce, 0);
	

    const dReal *a = dBodyGetPosition (m_body);
	float offset;
	if(x>0)
	{
		offset = m_length/2.0;
	}
	else
	{
		offset = -m_length/2.0;
	}

    dJointSetHingeAnchor (m_hinge_joint,a[0]+offset,a[1],a[2]);
  
//	dJointSetHingeAnchor (m_hinge_joint,m_length,0,0);
	
	dJointSetHingeAxis (m_hinge_joint,0,0,1);
    


	memset (m_geom,0,sizeof(m_geom));
	dMass m;	

	dMassSetBox (&m, 70.0f, m_length,m_radius,m_radius);
   
//	m_geom[0] = m_physics->createCyl(m_radius, m_length);
	m_geom[0] = m_physics->createBox(m_length,m_radius,m_radius);
	
	
    for (int k=0; k < GPB; k++) 
	{
      if (m_geom[k]) 
		  dGeomSetBody (m_geom[k],m_body);	// sets the body associated with a placeable geom
    }
    
    dBodySetMass (m_body,&m);	// Sets the mass of the body
//	dMassSetZero(&m);

//	dJointID my_fixed_joint = m_physics->createFixedJoin();
//	dJointAttach(my_fixed_joint, m_body,0);


	m_gllist = glGenLists(1);
	//bind the texture
	glBindTexture(GL_TEXTURE_2D, m_texture);

	// TODO Texture Mapping !
	glNewList(m_gllist, GL_COMPILE);
	glBegin(GL_TRIANGLES);
	// Unterseite
	glTexCoord2f(0.2f,1.0f);
	glVertex3f( 0.0f,  1.0f,  0.0f); // 1
	glTexCoord2f(1.0f,0.5f);
	glVertex3f( 4.0f,  0.0f,  0.0f); // 2
	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.0f); // 3

	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.0f); // 3
	glTexCoord2f(1.0f,0.5f);
	glVertex3f( 4.0f,  0.0f,  0.0f); // 2
	glTexCoord2f(0.2f,0.0f);
	glVertex3f( 0.0f, -1.0f,  0.0f); // 4

	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.0f); // 3
	glTexCoord2f(0.2f,0.0f);
	glVertex3f( 0.0f, -1.0f,  0.0f); // 4
	glTexCoord2f(0.0f,0.33f);
	glVertex3f(-1.0f, -0.5f,  0.0f); // 5

	glTexCoord2f(0.0f,0.66f);
	glVertex3f(-1.0f,  0.5f,  0.0f); // 6
	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.0f); // 3
	glTexCoord2f(0.0f,0.33f);
	glVertex3f(-1.0f, -0.5f,  0.0f); // 5

	glTexCoord2f(0.2f,1.0f);
	glVertex3f( 0.0f,  1.0f,  0.0f); // 1
	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.0f); // 3
	glTexCoord2f(0.0f,0.66f);
	glVertex3f(-1.0f,  0.5f,  0.0f); // 6
	
	// Oberseite
	glTexCoord2f(0.2f,1.0f);
	glVertex3f( 0.0f,  1.0f,  0.4f); // 1
	glTexCoord2f(1.0f,0.5f);
	glVertex3f( 4.0f,  0.0f,  0.4f); // 2
	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.4f); // 3

	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.4f); // 3
	glTexCoord2f(1.0f,0.5f);
	glVertex3f( 4.0f,  0.0f,  0.4f); // 2
	glTexCoord2f(0.2f,0.0f);
	glVertex3f( 0.0f, -1.0f,  0.4f); // 4

	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.4f); // 3
	glTexCoord2f(0.2f,0.0f);
	glVertex3f( 0.0f, -1.0f,  0.4f); // 4
	glTexCoord2f(0.0f,0.33f);
	glVertex3f(-1.0f, -0.5f,  0.4f); // 5

	glTexCoord2f(0.0f,0.66f);
	glVertex3f(-1.0f,  0.5f,  0.4f); // 6
	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.4f); // 3
	glTexCoord2f(0.0f,0.33f);
	glVertex3f(-1.0f, -0.5f,  0.4f); // 5

	glTexCoord2f(0.2f,1.0f);
	glVertex3f( 0.0f,  1.0f,  0.4f); // 1
	glTexCoord2f(0.2f,0.5f);
	glVertex3f( 0.0f,  0.0f,  0.4f); // 3
	glTexCoord2f(0.0f,0.66f);
	glVertex3f(-1.0f,  0.5f,  0.4f); // 6
	glEnd();

	glBegin(GL_QUADS);
	// Seiten
	glTexCoord2f(0.0f, 0.0f);
	glVertex3f( 0.0f,  1.0f,  0.0f); // 1
	glTexCoord2f(1.0f,0.0f);
	glVertex3f( 4.0f,  0.0f,  0.0f); // 2
	glTexCoord2f(1.0f,1.0f);
	glVertex3f( 4.0f,  0.0f,  0.4f); // 2
	glTexCoord2f(0.0f,1.0f);
	glVertex3f( 0.0f,  1.0f,  0.4f); // 1
	
	glTexCoord2f(0.0f,0.0f);
	glVertex3f( 0.0f, -1.0f,  0.0f); // 4
	glTexCoord2f(1.0f,0.0f);
	glVertex3f( 4.0f,  0.0f,  0.0f); // 2
	glTexCoord2f(1.0f,1.0f);
	glVertex3f( 4.0f,  0.0f,  0.4f); // 2
	glTexCoord2f(0.0f,1.0f);
	glVertex3f( 0.0f, -1.0f,  0.4f); // 4

	glTexCoord2f(0.0f,0.0f);
	glVertex3f( 0.0f, -1.0f,  0.0f); // 4
	glTexCoord2f(1.0f,0.0f);
	glVertex3f(-1.0f, -0.5f,  0.0f); // 5
	glTexCoord2f(1.0f,1.0f);
	glVertex3f(-1.0f, -0.5f,  0.4f); // 5
	glTexCoord2f(0.0f,1.0f);
	glVertex3f( 0.0f, -1.0f,  0.4f); // 4

	glTexCoord2f(0.0f,0.0f);
	glVertex3f(-1.0f,  0.5f,  0.0f); // 6
	glTexCoord2f(1.0f,0.0f);
	glVertex3f(-1.0f, -0.5f,  0.0f); // 5
	glTexCoord2f(1.0f,1.0f);
	glVertex3f(-1.0f, -0.5f,  0.4f); // 5
	glTexCoord2f(0.0f,1.0f);
	glVertex3f(-1.0f,  0.5f,  0.4f); // 6

	glTexCoord2f(0.0f,0.0f);
	glVertex3f( 0.0f,  1.0f,  0.0f); // 1
	glTexCoord2f(1.0f,0.0f);
	glVertex3f(-1.0f,  0.5f,  0.0f); // 6
	glTexCoord2f(1.0f,1.0f);
	glVertex3f(-1.0f,  0.5f,  0.4f); // 6
	glTexCoord2f(0.0f,1.0f);
	glVertex3f( 0.0f,  1.0f,  0.4f); // 1

	glEnd();
	glEndList();
}


Panel::~Panel(void)
{
	glDeleteLists(m_gllist, 1);
}

void Panel::addForceXYZ(double x, double y, double z)
{
	dBodyAddForce(m_body, x, y, z);	
}

void Panel::addTorqueXYZ(double x, double y, double z)
{
	dBodyAddTorque(m_body, x, y, z);	
}

void Panel::addTorqueOnAxis(double force){
	dJointAddHingeTorque(m_hinge_joint, force);
}

void Panel::setAngle(float angle)
{	
	m_angle = angle;	
}

void Panel::update()
{
	
	const double *pos = getPosition();
	const double *rot = getRotation();
	
	for(int i=0; i<2; i++){
		m_position[i] = (float)pos[i];
	}
	m_position[2] = 0.0f;	// set z-coordinate to zero

	for(int i=0; i<12; i++){
		m_rotation[i] = (float)rot[i];
	}

//	if((dJointGetHingeAngle (m_hinge_joint)>0.7)||(dJointGetHingeAngle (m_hinge_joint)<-0.4)){
//		dBodySetAngularVel(m_body, 0,0,0);
//	}

}


void Panel::draw(void)
{
glPushMatrix();


dReal sides[3] = {m_length,m_radius,m_radius};
dsDrawBoxD (dBodyGetPosition(m_body),dBodyGetRotation(m_body),sides);
//dsDrawCyl(dBodyGetPosition(m_body),dBodyGetRotation(m_body), m_radius, m_length);

// draw the rotation axis
dVector3 anchorpoint, axis;
dJointGetHingeAnchor (m_hinge_joint, anchorpoint);
dJointGetHingeAxis (m_hinge_joint, axis);
	
	//glLineWidth(5.0f);
	//glBegin(GL_LINES);
	//// X = red
	//	glColor3f(1.0f, 0.0f, 0.0f);
	//	glVertex3f(anchorpoint[0],anchorpoint[1],anchorpoint[2] );
	//	glVertex3f(anchorpoint[0]+axis[0], anchorpoint[1]+axis[1], anchorpoint[2]+axis[2]);
	//glEnd();



//dsDrawBoxD (dBodyGetPosition(m_hinge_body),dBodyGetRotation(m_hinge_body),sides);

//glTranslatef(m_position[0], m_position[1], m_position[2]);

setTransform(m_position,m_rotation);



	glScalef(m_scale, m_scale, m_scale);

	//Enable texturing
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, GetTexture());

	if (m_angle != 0.0f)
		glRotatef(m_angle, 0.0f, 0.0f, 1.0f);
	
	//glTranslatef(m_position[0], m_position[1], m_position[2]);
	
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	
	// Auf die Ebene des Boards anheben
	glTranslatef(0.0f, 0.0f, -0.4f);
	
	glCallList(m_gllist);

	//Disable texturing
	glDisable(GL_TEXTURE_2D);
	glPopMatrix();
}