#include ".\sound.h"

#include <iostream>
using namespace std;

Sound::Sound(void)
{

	// initialize the audio with 44.1kHz, 16bit
	if(Mix_OpenAudio(44100, AUDIO_S16SYS, 2, 4096 ) < 0)
	{
		cerr << "Warning: Couldn't set 44100 Hz 16-bit audio\n\
			   - Reason: " << SDL_GetError() << endl;
	} // if(Mix_OpenAudio(44100, AUDIO_S16SYS, 2, 4096) < 0)

	padLOk = true;
	padROk = true;


	// Load in the music // Maybe we have 2 types of music (GUI/GAME)
	 music = Mix_LoadMUS("../data/sound/bg.ogg");
	  // And sound effects
	shot = Mix_LoadWAV("../data/sound/shot.wav");
	bumper = Mix_LoadWAV("../data/sound/bumper.wav");
	pad = Mix_LoadWAV("../data/sound/pad.wav");


}

Sound::~Sound(void)
{
}

void Sound::playShot(void){       
	Mix_PlayChannel(0,shot,0);
}

void Sound::setLeftPadIsDown(){
	padLOk = true;
}

void Sound::setRightPadIsDown(){
	padROk = true;
}

void Sound::playBumper(void){       
     Mix_PlayChannel(0,bumper,0);
}

void Sound::playLeftPad(void){       
    if(padLOk)     
	Mix_PlayChannel(0,pad,0);
	padLOk = false;
}

void Sound::playRightPad(void){       
    if(padROk)     
	Mix_PlayChannel(0,pad,0);
	padROk = false;
}

void Sound::playMusic(void){
	// -1 = infinite loop
	Mix_PlayMusic(music,-1);
}

void Sound::fadeInMusic(int ms)
{
	// -1 = infinite loop
	Mix_FadeInMusic(music,-1, ms);
}

void Sound::fadeOffMusic(int ms)
{
	Mix_FadeOutMusic(ms);
}

void Sound::playCollisionSound(int geomclass){
	switch (geomclass){
//		case 11 :	//dFirstUserClass
		case 2: //dCCylinderClass
			playBumper();
			break;
		case 4:		//4dPlaneClass
			//playPad();
			break;
		case 1:	//	dBoxClass
			break;
		default:
		//	playShot();
			break;
	}
}
	/*int dGeomGetClass (dGeomID);

Given a geom, this returns its class number. The standard class numbers are:

dSphereClass	Sphere
dBoxClass	Box
dCCylinderClass	Capped cylinder
dCylinderClass	Regular flat-ended cylinder
dPlaneClass	Infinite plane (non-placeable)
dGeomTransformClass	Geometry transform
dRayClass	Ray
dTriMeshClass	Triangle mesh
dSimpleSpaceClass	Simple space
dHashSpaceClass	Hash table based space

*/
