#pragma once
#include <SDL_mixer.h>
#include <SDL.h>

class Sound
{
private: 
	Mix_Music *music;         // This will store our music
	Mix_Chunk *shot;          // This will store our shot sound
	Mix_Chunk *bumper;        // This will store our "bumper" sound
	Mix_Chunk *pad;        // This will store our "pad" sound

	bool padLOk;
	bool padROk;
public:
	
	Sound(void);
	~Sound(void);

	void playShot(void);
	void playBumper(void);
	void playLeftPad(void);
	void playRightPad(void);
	void playMusic(void);
	void playCollisionSound(int geomclass);
	void fadeOffMusic(int ms);
	void fadeInMusic(int ms);

	void setLeftPadIsDown();
	void setRightPadIsDown();

};
