#include ".\textscreen.h"

TextScreen::TextScreen(std::string m_Filename)
{
		//Load Bitmap
	SDL_Surface* bmpFile = SDL_LoadBMP(m_Filename.c_str());
	
	if (bmpFile != NULL)
	{
		if (bmpFile->w < 1) {
			SDL_FreeSurface(bmpFile);
			return;
		} else if ( !((bmpFile->w & (bmpFile->w-1)) == 0) ) {
			SDL_FreeSurface(bmpFile);
			return ;
		}    

		glPixelStorei(GL_UNPACK_ALIGNMENT,4);

		m_texture = 0;
		glGenTextures(1,&m_texture);

		if (m_texture == 0)
		{
			throw "Could not load texture...";
		}
		glBindTexture(GL_TEXTURE_2D,m_texture);

		// TEST
		//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		//glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

		//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		
		
		//gluBuild2DMipmaps(GL_TEXTURE_2D,3,bmpFile->w,
		//	bmpFile->h,GL_BGR_EXT,
		//	GL_UNSIGNED_BYTE,bmpFile->pixels);

		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, bmpFile->w, bmpFile->h, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE, bmpFile->pixels);

		//Free surface after using it
		SDL_FreeSurface(bmpFile);
	}
	m_alpha = 1.0f;
	m_size = 0.8f;
	m_fadestep = 0.05f;
	m_times_seen = 0;
}
TextScreen::TextScreen(void)
{
}

TextScreen::~TextScreen(void)
{
	glDeleteTextures(1, &m_texture);
}

void TextScreen::draw(void)
{
	//Enable texturing
	glEnable(GL_TEXTURE_2D);
	//bind the texture
	glBindTexture(GL_TEXTURE_2D, m_texture);
	glColor4f(1.0f, 1.0f, 1.0f, m_alpha);

	glBegin(GL_QUADS);
		glTexCoord2i(0,1);
		//glVertex2f(-m_size, -m_size); //lower left
		glVertex2f(-1, -1); //lower left
		glTexCoord2i(0,0);
		//glVertex2f(-m_size, m_size); //upper left
		glVertex2f(-1, 0.8f); //upper left
		glTexCoord2i(1,0);
		//glVertex2f(m_size, m_size); //upper right
		glVertex2f(1, 0.8f); //upper right
		glTexCoord2i(1,1);
		//glVertex2f(m_size, -m_size); //lower right
		glVertex2f(1, -1); //lower right
	glEnd();

	//Disable texturing
	glDisable(GL_TEXTURE_2D);

	m_alpha -= m_fadestep;
	if (m_alpha < 0.0f)
	{
		m_alpha = 0.0f;
		m_times_seen++;
	}
}

float TextScreen::getAlpha(void)
{
	return m_alpha;
}

void TextScreen::setAlpha(float alpha)
{
	// no range check !!!
	m_alpha = alpha;
}

int TextScreen::getTimesSeen(void)
{
	return m_times_seen;
}
void TextScreen::resetTimesSeen(void)
{
	m_times_seen = 0;
}
