// AR-Praktikum ss2005 - Basti Grembowietz
#pragma once
// stl-department
#include <iostream>
#include <sstream>

// oCV-department
//#include <tchar.h>
//#include <cv.h>
//#include <highgui.h>

#include <GL/freeglut.h>
//#include <GL/glut.h> // haha...

// own department
#include "ImageSource.h"
#include "MarkerTracker.h"
#include "PoseEstimation.h"
#include "Visualization.h"

using namespace std; // for using cout directly.

// global variable 8( for communication with glutDisplayFunc(). bah.
Visualization * vis;
MarkerTracker * tracker;

void updateF()
{
	// poor encapsulation but ...
	vis->update();
}

void idleF()
{
    glutPostRedisplay();
}

void resize(int width, int height)
{
	// inform visualization about it
	vis->setDimensions(width, height);
}

void keyboard( unsigned char key, int mouseX, int mouseY )
{
    switch(key)
	{
	case 27 : // == esc
		glutLeaveMainLoop();
		break;
	case '+':
		cout << " thresh= " << std::dec << tracker->incThreshold() << endl;
		break;
	case '-':
		cout << " thresh= " << std::dec << tracker->decThreshold() << endl;
		break;
	}
}


int main(int argc, char * argv[])
{

	ImageSource * mySource = NULL;
	try
	{
		// aquire camera
		mySource = new BCamera();
//		mySource = new BPicture("E:\\prog-zone\\my_sources\\arPraktikum\\buidl\\buidl1.jpg");
	}
	catch(std::exception &e)
	{
		MessageBox(NULL, e.what(), "AR-Prakt 05-19", MB_OK);
		return -1;		
	}

	tracker = new MarkerTracker();
	tracker->setSource(mySource);

	tracker->readMarkerConfig("marker.cfg");

	glutInit(&argc, argv);

//	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
//	glViewport( -(mySource->getWidth()/2), -(mySource->getWidth()/2), -mySource->getHeight()/2, mySource->getHeight()/2 );
//	glViewport( -(mySource->getWidth()/2), -(mySource->getHeight()/2), mySource->getWidth()/2, mySource->getHeight()/2 );
	glViewport( 0, 0, mySource->getWidth(), mySource->getHeight());

	glutInitWindowSize(mySource->getWidth(), mySource->getHeight());
	glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
	glutCreateWindow("AR with GL");


	vis = new Visualization(tracker, mySource);


	glutDisplayFunc(updateF);
	glutKeyboardFunc(keyboard);
    glutReshapeFunc(resize);
	glutIdleFunc(idleF);
//	glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE, GLUT_ACTION_CONTINUE_EXECUTION);
	glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE, GLUT_ACTION_GLUTMAINLOOP_RETURNS);

	cout << "Augmented Reality Praktikum 2005" <<endl;

	glutMainLoop();

	// properly release my objects
	delete mySource;
	delete tracker;
	delete vis;

	//bye bye
	return 0;
}

